// AjaxHandler

var guidGen = require("./guidGenerator.js");


// After these milliseconds, an empty response will be sent.
var RESPONSE_TIMEOUT = 5000;
//If a client doesn't do anything for these milliseconds, it will be considered disconnected
var CLIENT_DISCONNECTION_TIMEOUT = 10000;
// Demon delay
var DAEMON_DELAY = 2000;


// Connected clients' GUID and last action time
var clients = new Array();
// Unsent response
var resps = new Array();
// Unsent getDraw response
var drawResps = new Array();


// method CONNECTION REQUEST
var connectionRequest = function(req, res) {
	var list = "";
	var guid = guidGen.generate();
	for (var i=0, len = clients.length; i < len; i++) {
		list += "newguid|" +clients[i][0]+"-"
	}
	var text = "yourguid|"+guid+"-"+list;
	res.send(200, text);
	var len = resps.length;
	while (len--) {
		resps[len].send(200, "newguid|"+guid);
		console.log("[Ajax] /users request served");
		resps.splice(len, 1);
	}
	clients.push(new Array(guid, new Date().getTime()));
}


// method ONLINE CLIENTS REQUEST
var onlineClientsRequest = function(req, res) {
	resps.push(res);
	var guid = req.params.GUID;
	for (var i = 0; i < clients.length; i++) {
		if (clients[i][0] == guid) {
			clients[i][1] = new Date().getTime();
			break;
		}
	}	
	console.log("[Ajax] "+guid+" /users request accepted..");
	setTimeout(function(){ timeoutCallback(res)}, RESPONSE_TIMEOUT);
	function timeoutCallback(res) {
		var len = resps.length;
		while (len--) {
			if (resps[len] == res) {
				console.log("[Ajax] /users request timeout");
				res.send(200, "timeout");
				resps.splice(len, 1);
				break;
			}
		}
	}
}


// method GET DRAW REQUEST
var getDrawRequest = function(req, res) {
	var guid = req.params.GUID;
	drawResps.push(new Array(res, guid));
	console.log("[Ajax] "+guid+" /getDraw request accepted..");
	setTimeout(function(){ timeoutDrawCallback(res)}, RESPONSE_TIMEOUT);
	function timeoutDrawCallback(res) {
		var len = drawResps.length;
		while (len--) {
			if (drawResps[len][0] == res) {
				console.log("[Ajax] /getDraw request timeout");
				res.send(200, "timeout");
				drawResps.splice(len, 1);
				break;
			}
		}
	}
}


// method POST DRAW REQUEST
var postDrawRequest = function(req, res) {
	var text = req.body.text;
	var guid = req.body.guid;
	res.send(200, "received");
	var len = drawResps.length;
	while (len--) {
		if (drawResps[len][1] != guid) {
			drawResps[len][0].send(200, text);
			console.log("[Ajax] /draw request served");
			drawResps.splice(len, 1);
		}
	}
}


// method startDisconnectCheckDaemon
var startDisconnectCheckDaemon = function() {
	var len = clients.length;
	while (len--) {
		if (new Date().getTime() - clients[len][1] > CLIENT_DISCONNECTION_TIMEOUT) {
			console.log("[Ajax] GUID "+clients[len][0]+" disconnected");
			var len2 = resps.length;
			while (len2--) {
				resps[len2].send(200, "quit|"+clients[len][0]);
				console.log("[Ajax] /users request served");
				resps.splice(len2, 1);
			}
			clients.splice(len, 1);
		}
	}
	setTimeout(startDisconnectCheckDaemon, DAEMON_DELAY);
}


//Node.js module's methods export
exports.connectionRequest = connectionRequest;
exports.onlineClientsRequest = onlineClientsRequest;
exports.getDrawRequest = getDrawRequest;
exports.postDrawRequest = postDrawRequest;
exports.startDisconnectCheckDaemon = startDisconnectCheckDaemon;