// HttpServer

var http = require("http");
var express = require('express');


var HTTP_SERVER_PORT = 80;


var httpServer;
var app;


// method INIT
var init = function() {
	console.log("[HttpServer] Init");
	app = express();
	app.configure(function() {
	    app.use(express.static(__dirname + "/public"));
	    app.use(express.json());
	    app.use(express.urlencoded());
	});
	httpServer = http.createServer(app);
	app.get('/clientWebSocket', function(req, res) {
		res.sendfile('public/webSocket/client.html');
	});
	app.get('/clientAjax', function(req, res) {
		res.sendfile('public/ajax/client.html');
	});	
}


// method START
var start = function() {
	httpServer.listen(HTTP_SERVER_PORT);
}


//method SET AJAX HANDLER
var setAjaxHandlers = function(ajaxHandler) {
	app.get('/firstRequest', function(req, res) {
		ajaxHandler.connectionRequest(req, res);
	});
	app.get('/users/:GUID', function(req, res) {
		ajaxHandler.onlineClientsRequest(req, res);
	});
	app.get('/getDraw/:GUID', function(req, res) {	
		ajaxHandler.getDrawRequest(req, res);
	});
	app.post('/draw', function(req, res) {
		ajaxHandler.postDrawRequest(req, res);
	});
}


// method GET SERVER
var getServer = function() {
	return httpServer;
}


// Node.js module's methods export
exports.init = init;
exports.start = start;
exports.setAjaxHandlers = setAjaxHandlers;
exports.getServer = getServer;