// NetworkLayer

networkLayer = new Object();

// parameters
networkLayer.isOnline = false;
networkLayer.localGUID = null;
networkLayer.message = "";
networkLayer.connectAjax;
networkLayer.userAjax;
networkLayer.sendAjax;
networkLayer.drawAjax;
networkLayer.aborted = false;

// method CONNECT
networkLayer.connect = function() {
	this.aborted = false;
	view.logConnection("Ajax long polling started");
	view.changeConnectStatus(0);
	view.logMessages("GET /firstRequest", 0);
	this.connectAjax = $.ajax({
		url: "firstRequest",
		type: "GET",
	});
	this.connectAjax.done(function( msg ) {
		var messages = msg.split("-");
		for (var i = 0; i < messages.length; i++) {
			if (messages[i] != "") {
				var tokens = messages[i].split("|");
				if (tokens[0] == "yourguid") {
					networkLayer.localGUID = tokens[1];
					view.logClients(networkLayer.localGUID+"&nbsp;&nbsp;&nbsp;&nbsp;(you)", 1);
				}
				if (tokens[0] == "newguid") {
					view.logClients(tokens[1], 1);
				}
			}
		}
		if (msg != "timeout") {
			view.logMessages("response received", 0);
		}
		networkLayer.isOnline = true;
		networkLayer.userRequest();
		networkLayer.drawRequest();
	});
	this.connectAjax.fail(function( jqXHR, textStatus ) {
		view.logMessages("-closed-", 0)
		networkLayer.disconnect();
	});
}


// method STORE DATA
networkLayer.storeData = function(text) {
	this.message = this.message + text + "-";
}


// method SEND DATA
networkLayer.sendData = function() {
	if (this.isOnline) {
		view.logMessages("POST /draw", 1);
		this.sendAjax = $.ajax({
			url: "draw",
			data: {"guid": networkLayer.localGUID, "text": networkLayer.localGUID+"-"+this.message},
			type: "POST",
		});
		this.message = "";
		this.sendAjax.fail(function( jqXHR, textStatus ) {
			networkLayer.disconnect();
		});
	}
}


// method USER REQUEST
networkLayer.userRequest = function() {
	view.logMessages("GET /users/"+networkLayer.localGUID, 0);
	this.userAjax = $.ajax({
		url: "users/"+ networkLayer.localGUID,
		type: "GET",
	});
	this.userAjax.done(function( msg ) {	
		var tokens = msg.split("|");
		if (msg != "timeout") {
			view.logMessages(msg, 0);
		}
		if (tokens[0] == "newguid") {
			view.logClients(tokens[1], 1);
		}
		if (tokens[0] == "quit") {
			view.logClients(tokens[1], 0);
			paintBoard.removeRemoteCoords(tokens[1]);
		}
		networkLayer.userRequest();
	});
	this.userAjax.fail(function( jqXHR, textStatus ) {
		view.logMessages("-closed-", 0)
		networkLayer.disconnect();
	});
}


// method DRAW REQUEST
networkLayer.drawRequest = function() {
	view.logMessages("GET /getDraw/"+networkLayer.localGUID, 1);
	this.drawAjax = $.ajax({
		url: "getDraw/"+ networkLayer.localGUID,
		type: "GET",
	});
	this.drawAjax.done(function( msg ) {
		if (msg != "timeout") {
			var messages = msg.split("-");
			for (var i = 1; i < messages.length; i++) {
				if (messages[i] != "") {
					var tokens = messages[i].split("|");
					paintBoard.remoteDraw(tokens[0], tokens[1], tokens[2], messages[0], tokens[3], tokens[4]);
				}
			}
			view.logMessages("response received", 1);
		}
		networkLayer.drawRequest();
		// DEBUGGGGGGGG
		//view.logMessages("timeout", 1);
		//setTimeout(function() {
		//	networkLayer.drawRequest();
		//	}, 5000);
		// FINE DEBUGGGGG
	});
	this.drawAjax.fail(function( jqXHR, textStatus ) {
		view.logMessages("-closed-", 1)
		networkLayer.disconnect();
	});
}


// method DISCONNECT
networkLayer.disconnect = function() {
	this.isOnline = false;
	if (this.connectAjax != undefined) this.connectAjax.abort();
	if (this.userAjax != undefined) this.userAjax.abort();	
	if (this.sendAjax != undefined) this.sendAjax.abort();
	if (this.drawAjax != undefined) this.drawAjax.abort();
	if (this.aborted == false) {
		view.logConnection("Ajax request closed");
		this.aborted = true;
	}
	view.clearClients();
	view.changeConnectStatus(1);
}