// NetworkLayer

networkLayer = new Object();

// parameters
networkLayer.SOCKET_URL = "ws://127.0.0.1";
networkLayer.socket = null;
networkLayer.isOnline = false;
networkLayer.localGUID = null;


// method CONNECT
networkLayer.connect = function() {
	view.logConnection("Connecting..");
	var wsCtor = window['MozWebSocket'] ? MozWebSocket : WebSocket;
	this.socket = new wsCtor(this.SOCKET_URL, 'paintBoard-protocol');
	
	this.socket.onopen = function() {
		networkLayer.isOnline = true;
		view.logConnection("Connected");
		view.changeConnectStatus(0);
	}
	
	this.socket.onmessage = function(message) {
		networkLayer.msgReceivedHandler(message);
	}
	
	this.socket.onclose = function() {
		networkLayer.isOnline = false;
		view.logConnection("Disconnected");
		view.changeConnectStatus(1);
		view.clearClients();
	};			
};


// method MSG RECEIVED HANDLER
networkLayer.msgReceivedHandler = function(message) {
	view.logMessages(message.data, 1);
	var tokens = message.data.split("|");	
	if (tokens[0] == "yourguid") {
		this.localGUID = tokens[1];
		view.logClients(this.localGUID+"&nbsp;&nbsp;&nbsp;&nbsp;(you)", 1);
	}
	if (tokens[0] == "newguid") {
		view.logClients(tokens[1], 1);
	}
	if (tokens[0] == "quit") {
		view.logClients(tokens[1], 0);
		paintBoard.removeRemoteCoords(tokens[1]);
	}
	if (tokens[0] == "draw") {
		paintBoard.remoteDraw(tokens[2], tokens[3], tokens[4], tokens[1], tokens[5], tokens[6]);
	}	
}


// method SEND DATA
networkLayer.sendData = function(text) {
	if (networkLayer.isOnline) {
		message = "draw|" + this.localGUID +"|"+text;
		view.logMessages(message, 2);
		this.socket.send(message);
	}
}


// method DISCONNECT
networkLayer.disconnect = function() {
	this.socket.close();
}