// SharedPaintBoard

paintBoard = new Object();

// parameters
paintBoard.canvasContext = null;
paintBoard.canvas = null;
paintBoard.mousePressed = false;
paintBoard.lastX = null;
paintBoard.lastY = null;
paintBoard.lineColor = "black";
paintBoard.lineSize = 5;
paintBoard.remoteLastX = [];
paintBoard.remoteLastY = [];


// method INIT
paintBoard.init = function() {
	this.canvas = view.getCanvas();
	this.canvasContext = this.canvas.getContext("2d");
}


// method DRAW
paintBoard.draw = function(x, y, pressed) {
	networkLayer.sendData(x+"|"+y+"|"+pressed+"|"+this.lineColor+"|"+this.lineSize);
	if (pressed) {
		this.canvasContext.beginPath();
		this.canvasContext.strokeStyle = this.lineColor;
		this.canvasContext.lineWidth = this.lineSize;
		this.canvasContext.lineJoin = "round";
		this.canvasContext.moveTo(this.lastX, this.lastY);
		this.canvasContext.lineTo(x, y);
		this.canvasContext.closePath();
		this.canvasContext.stroke();
	}
	this.lastX = x; this.lastY = y;
}


//method CLEAR
paintBoard.clear = function() {
	this.canvasContext.setTransform(1, 0, 0, 1, 0, 0);
	this.canvasContext.clearRect(0, 0, this.canvasContext.canvas.width, this.canvasContext.canvas.height);
}


//method REMOTE DRAW
paintBoard.remoteDraw = function(x, y, pressed, GUID, lineColor, lineSize) {
	if (pressed == "true") {
		this.canvasContext.beginPath();
		this.canvasContext.strokeStyle = lineColor;
		this.canvasContext.lineWidth = lineSize;
		this.canvasContext.lineJoin = "round";
		this.canvasContext.moveTo(this.remoteLastX[GUID], this.remoteLastY[GUID]);
		this.canvasContext.lineTo(x, y);
		this.canvasContext.closePath();
		this.canvasContext.stroke();
	}
	this.remoteLastX[GUID] = x; 
	this.remoteLastY[GUID] = y;
}


//method REMOVE REMOTE COORDS
paintBoard.removeRemoteCoords = function(GUID) {
	if (this.remoteLastX[GUID] != undefined && this.remoteLastY[GUID] != undefined) {
		this.remoteLastX.splice(GUID, 1);
		this.remoteLastY.splice(GUID, 1);
	}
}
